#!/usr/bin/perl
## psfonts.pl (Ver. 1.0.0)
## (C) 2003 Takeshi WATANABE <t-wata@dab.hi-ho.ne.jp>
########################################################################
##
## encoding
##
$encoding{"H"} = "H";
$encoding{"V"} = "V";
$encoding{"R"} = "83pv-RKSJ-H";
##
if ($ARGV[0] =~ /^\-jis$/i) { # default
    shift @ARGV;
} elsif ($ARGV[0] =~ /^\-sjis$/i) {
    $encoding{"H"} = "RKSJ-H";
    $encoding{"V"} = "RKSJ-V";
    $encoding{"R"} = "83pv-RKSJ-H";
    shift @ARGV;
} elsif ($ARGV[0] =~ /^\-mac$/i) {
    $encoding{"H"} = "83pv-RKSJ-H";
    $encoding{"V"} = "90pv-RKSJ-V";
    $encoding{"R"} = "83pv-RKSJ-H";
    shift @ARGV;
} elsif ($ARGV[0] =~ /^\-win$/i) {
    $encoding{"H"} = "90ms-RKSJ-H";
    $encoding{"V"} = "90ms-RKSJ-V";
    $encoding{"R"} = "90msp-RKSJ-H";
    shift @ARGV;
}
##
## Postscript font name
##
%psfonts =
    (
     "ryumin-l",	"Ryumin-Light",
     "ryumin-r",	"Ryumin-regular",
     "ryumin-m",	"Ryumin-Medium",
     "ryumin-b",	"Ryumin-Bold",
     "ryumin-h",	"Ryumin-heavy",
     "ryumin-u",	"Ryumin-Ultra",
#
     "shingo-l",	"ShinGo-Light",
     "shingo-r",	"ShinGo-regular",
     "shingo-m",	"ShinGo-Medium",
     "shingo-b",	"ShinGo-Bold",
     "shingo-h",	"ShinGo-heavy",
     "shingo-u",	"ShinGo-Ultra",
#
     "jun101-l",	"Jun101-Light",
     "jun201-r",	"Jun201-regular",
     "jun34-m",		"Jun34-Medium",
     "jun501-b",	"Jun501-Bold",
#
     "gt101-b",		"GothicMB101-Bold",
     "gt101-h",		"GothicMB101-heavy",
     "gt101-u",		"GothicMB101-Ultra",
#
     "kyoka-l",		"KyokaICA-Light",
     "kyoka-r",		"KyokaICA-regular",
     "kyoka-m",		"KyokaICA-Medium",
#
     "gtbbb-m",		"GothicBBB-Medium",
     "futomin-b",	"FutoMinA101-Bold",
     "futogo-b",	"FutoGoB101-Bold",
     "midashimin",	"MidashiMin-MA31",
     "midashigo",	"MidashiGo-MB31",
     );
##
## main loop
##
foreach (@ARGV) {
    if (/^([HVR])\-?J?(\d*)\-(.+)$/) {
	printf "%s\t%s-%s", $_, $psfonts{$3}, $encoding{$1};
	if ($2 ne "") {
	    printf "\t\"%.3f ExtendFont \"", $2 / 1000.;
	}
	print "\n";
    }
}
exit;
##EOF
